/* btoa: version 4.0
 * stream filter to change 8 bit bytes into printable ascii
 * computes the number of bytes, and three kinds of simple checksums
 * incoming bytes are collected into 32-bit words, then printed in base 85
 *  exp(85,5) > exp(2,32)
 * the ASCII characters used are between '!' and 'u'
 * 'z' encodes 32-bit zero; 'x' is used to mark the end of encoded data.
 *
 *  Paul Rutter     Joe Orost
 *  philabs!per     petsd!joe
 *
 *  WARNING: this version is not compatible with the original as sent out
 *  on the net.  The original encoded from ' ' to 't'; which cause problems
 *  with some mailers (stripping off trailing blanks).
 */

/*  DjG             Don Gloistein   11/11/88
 *  made some changes for both Msdos and compatibility.
 *  setbinary() is a define to force stdin/stdout to binary mode, needed
 *  for operating systems with text/binary modes of operation
 *  many initializations and tests changed constants to long. There were
 *  problems with conversion with my compiler. Changed some count variables
 *  to int. There was no need for longs. There was a bug with the multip.
 *  and mod functions. Without the 85 cast to a long, the wrong codes were
 *  generated. Moved some function positions to prototype themselves.
 */

#include <stdio.h>

#if defined(MSDOS)
#include <fcntl.h>
#include <io.h>
#define setbinary(fp) setmode(fileno((fp)),O_BINARY)
#else
#define setbinary(fp)
#endif

#define reg register

#define MAXPERLINE 78

long int Ceor = 0L;
long int Csum = 0L;
long int Crot = 0L;

int ccount = 0;
int bcount = 0;
long int word;

#define EN(c)   (int) ((c) + '!')

charout(c)
int c;
{
  putchar(c);
  ccount++;
  if (ccount == MAXPERLINE) {
    putchar('\n');
    ccount = 0;
  }
}

wordout(word)
  reg long int word;
{
  if (word == 0L) {
    charout('z');
  } else {
    reg int tmp = 0;

    if(word < 0L) {  /* Because some don't support unsigned long */
      tmp = 32;
      word -= (long)(85L * 85 * 85 * 85 * 32);
    }
    if(word < 0L) {
      tmp = 64;
      word -=  (long)(85L * 85 * 85 * 85 * 32);
    }
    charout(EN((word / (long)(85L * 85 * 85 * 85)) + tmp));
    word %= (long)(85L * 85 * 85 * 85);
    charout(EN(word / (85L * 85 * 85)));
    word %= (85L * 85 * 85);
    charout(EN(word / (85L * 85)));
    word %= (85L * 85);
    charout(EN(word / 85L));
    word %= 85L;
    charout(EN(word));
  }
}

encode(c)
  reg c;
{
  Ceor ^= c;
  Csum += c;
  Csum++;
  if ((Crot & 0x80000000)) {
    Crot <<= 1;
    Crot++;
  } else {
    Crot <<= 1;
  }
  Crot += c;

  word <<= 8;
  word |= c;
  if (bcount == 3) {
    wordout(word);
    bcount = 0;
  } else {
    bcount++;
  }
}



main(argc,argv)
  char **argv;
{
  reg c;
  reg long int n;

  if (argc != 1) {
    fprintf(stderr,"bad args to %s\n", argv[0]);
    exit(2);
  }
  setbinary(stdin);
  setbinary(stdout);
  printf("xbtoa Begin\n");
  n = 0L;
  while ((c = getchar()) != EOF) {
    encode(c);
    n++;
  }
  while (bcount != 0) {
    encode(0);
  }
  /* n is written twice as crude cross check*/
  printf("\nxbtoa End N %ld %lx E %lx S %lx R %lx\n", n, n, Ceor, Csum, Crot);
  exit(0);
}
